<!---终端入网检测-->
<template>
    <TableHeader area datePicker nextFlag theCurrentTime showTimeAll ref="TableHeaderRef" showExport showCustomColumn>
        <template #select>
            <el-form-item label="搜索">
                <el-input v-model="tableStore.table.params.searchValue" placeholder="输入变电站、终端、监测点名称"
                    clearable style="width: 280px" maxlength="32" show-word-limit></el-input>
            </el-form-item>
            <el-form-item label="流程状态">
                <el-select v-model="tableStore.table.params.status" clearable placeholder="请选择流程状态" filterable>
                    <el-option v-for="item in statusSelect" :key="item.id" :label="item.name"
                        :value="item.id"></el-option>
                </el-select>
            </el-form-item>
        </template>
        <template #operation>
            <el-button icon="el-icon-Plus" type="primary" @click="addFormModel">新增</el-button>
            <el-button icon="el-icon-Delete" type="primary" @click="deleteEven">删除</el-button>
            <!-- <el-button icon="el-icon-Download" @click="exportEvent" type="primary">导出</el-button> -->
        </template>
    </TableHeader>
    <Table ref="tableRef" :checkbox-config="checkboxConfig" />

    <!-- 新增弹框 -->
    <addForm ref="addForms" @onSubmit="tableStore.index()"></addForm>
</template>
<script setup lang="ts">
import { ref, onMounted, provide, watch } from 'vue'
import TableStore from '@/utils/tableStore'
import Table from '@/components/table/index.vue'
import TableHeader from '@/components/table/header/index.vue'
import { useRouter } from 'vue-router'
import { useDictData } from '@/stores/dictData'
import { getLoadTypeUserList } from '@/api/process-boot/interference'
import addForm from './addForm.vue'
import { useAdminInfo } from '@/stores/adminInfo'
import { ElMessage } from 'element-plus'
import { ElMessageBox } from 'element-plus/es'
import { cancelMointorPointFormData, getTempLineDetailsById } from '@/api/supervision-boot/monitorpoint/index'
import { deleteTempLineReport } from '@/api/supervision-boot/delete/index'
import { getTerminalDetailsById } from "@/api/supervision-boot/terminal";
//获取登陆用户姓名和部门
const adminInfo = useAdminInfo()
const dictData = useDictData()
const { push, options, currentRoute } = useRouter()
const flag = ref(false)
const TableHeaderRef = ref()
const tableRef = ref()
const areaOptionList = dictData.getBasicData('jibei_area')
const statusSelect = dictData.statusSelect()

const ruleFormRef = ref()
const show: any = ref(false)
const fileList = ref([])
const tableStore = new TableStore({
    url: '/supervision-boot/tempLine/list',
    publicHeight: 65,
    method: 'POST',
    filename:'监测点台账录入',
    column: [
        {
            width: '60',
            type: 'checkbox'
        },
        { title: '序号',  width: 80,formatter: (row: any) => {
        return (tableStore.table.params.pageNum - 1) * tableStore.table.params.pageSize + row.rowIndex + 1
      } },
        // { field: 'orgName', title: '填报部门名称', minWidth: 170 },
        {
            field: 'powerSubstationName',
            title: '电网侧电站',
            minWidth: 170,
            formatter: (row: any) => {
                return row.cellValue ? row.cellValue : '/'
            }
        },
        { field: 'connectedBus', title: '关联母线', minWidth: 170 },
        { field: 'monitoringTerminalName', title: '所属终端', minWidth: 170 },
        { field: 'lineName', title: '监测点名称', minWidth: 150 },
        { field: 'reportDate', title: '填报日期', minWidth: 150 },
        {
            field: 'createBy',
            title: '填报人',
            minWidth: 80,
            formatter: (row: any) => {
                return dictData.state.userList.filter(item => item.id == row.cellValue)[0]?.name
            }
        },
        {
            field: 'status',
            title: '流程状态',
            minWidth: 100,
            render: 'tag',
            custom: {
                0: 'warning',
                1: 'primary',
                2: 'success',
                3: 'danger',
                4: 'warning'
            },
            replaceValue: {
                0: '待提交审批',
                1: '审批中',
                2: '审批通过',
                3: '审批不通过',
                4: '已取消'
            }
        },
        {
             title: '操作',fixed: 'right',
            minWidth: 150,
         
            render: 'buttons',
            buttons: [
                {
                    name: 'productSetting',
                    title: '流程详情',
                    type: 'primary',
                    icon: 'el-icon-EditPen',
                    render: 'basicButton',
                    disabled: row => {
                        return !row.processInstanceId
                    },
                    click: row => {
                        flag.value = true
                        console.log(row.processInstanceId,row.historyInstanceId)
                        handleAudit(row.processInstanceId, row.historyInstanceId)
                    }
                },
                {
                    name: 'edit',
                    title: '编辑',
                    type: 'primary',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    showDisabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 0)
                    },

                    disabled: row => {
                        return !(row.status == 0)
                    },
                    click: row => {
                        addForms.value.open({
                            title: '编辑',
                            row: row
                        })
                    }
                },
                {
                    name: 'edit',
                    title: '重新发起',
                    type: 'warning',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || !(row.status == 3 || row.status == 4)
                    },
                    click: row => {
                        addForms.value.open({
                            title: '重新发起',
                            row: row
                        })
                    }
                },
                {
                    name: 'cancel',
                    title: '取消',
                    type: 'danger',
                    icon: 'el-icon-Open',
                    render: 'basicButton',
                    disabled: row => {
                        return row.createBy != adminInfo.$state.id || row.status != 1
                    },
                    click: row => {
                        cancelLeave(row)
                    }
                }
            ]
        }
    ],

    beforeSearchFun: () => {
        tableStore.table.params.orgNo = tableStore.table.params.deptIndex
        // tableStore.table.params.relationUserName = tableStore.table.params.userName
    },
    exportProcessingData: () => {
        tableStore.table.allData = tableStore.table.allData.filter(item => {
            item.status =
                item.status == 0
                    ? '待提交审批'
                    : item.status == 1
                    ? '审批中'
                    : item.status == 2
                    ? '审批通过'
                    : item.status == 3
                    ? '审批不通过'
                    : '已取消'
            return item
        })
    }
})
tableStore.table.params.status = ''
tableStore.table.params.searchValue = ''
// tableStore.table.params.loadType = ''
// tableStore.table.params.userName = ''
// tableStore.table.params.fileUploadflag = ''

provide('tableStore', tableStore)

const addForms = ref()
const addFormModel = () => {
    setTimeout(() => {
        addForms.value.open({
            title: '监测点信息'
        })
    }, 0)
}
/**取消流程操作*/
const cancelLeave = async (row: any) => {
    // 二次确认
    const { value } = await ElMessageBox.prompt('请输入取消原因', '取消流程', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        inputType: 'textarea',
        inputPattern: /^[\s\S]*.*\S[\s\S]*$/, // 判断非空，且非空格
        inputErrorMessage: '取消原因不能为空'
    })
    // 发起取消
    let data = {
        id: row.id,
        processInstanceId: row.processInstanceId,
        reason: value
    }
    await cancelMointorPointFormData(data)
    ElMessage.success('取消成功')
    // 加载数据
    tableStore.index()
}
// 禁止点击
const checkboxConfig = reactive({
    checkMethod: ({ row }) => {
        return adminInfo.roleCode.includes('delete_info')
            ? true
            : row.createBy == adminInfo.$state.id && row.status == 0
    }
})
const deleteEven = () => {
    if (tableStore.table.selection.length == 0) {
        ElMessage({
            type: 'warning',
            message: '请选择要删除的数据'
        })
    } else {

        ElMessageBox.confirm('此操作将永久删除, 是否继续?', '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
        })
            .then(() => {

                deleteTempLineReport(tableStore.table.selection.map(item => item.id)).then(res => {
                    ElMessage({
                        type: 'success',
                        message: '删除成功!'
                    })
                    tableStore.index()
                })
            })

    }
}

const exportEvent = () => {
    let form = JSON.parse(JSON.stringify(tableStore.table.params))
    form.pageNum = 1
    form.pageSize = tableStore.table.total
    getLoadTypeUserList(form).then(res => {
        tableRef.value.getRef().exportData({
            filename: '未建档非线性用户', // 文件名字
            sheetName: 'Sheet1',
            type: 'xlsx', //导出文件类型 xlsx 和 csv
            useStyle: true,
            data: res.data.records, // 数据源 // 过滤那个字段导出
            columnFilterMethod: function (column: any) {
                return !(column.$columnIndex === 0)
            }
        })
    })
}
onMounted(() => {
    tableStore.index()
})
watch(
    () => currentRoute.value.path,
    () => {
        if (flag.value && options.history.state.forward?.split('/')[1] == 'bpm') {
            tableStore.index()
            flag.value = false
        }
    },
    {
        deep: true
    }
)

/** 处理审批按钮 */
const handleAudit = (instanceId: any, historyInstanceId: any) => {
    push({
        name: 'BpmProcessInstanceDetail',
        state: {
            id: instanceId,
            historyInstanceId
        }
    })
}

const props = defineProps({ id: { type: String, default: 'null' } })
watch(() => props.id, async (newValue, oldValue) => {
    if (newValue === 'null') return // 直接返回，避免后续逻辑执行
    const fullId = newValue.split('@')[0]
    let nowTime = Date.now()
    const routeTime = Number(newValue.split('@')[1])
    if (isNaN(routeTime) || nowTime - routeTime > import.meta.env.VITE_ROUTE_TIME_OUT) return // 路由时间超过500ms，则不执行
    await getTempLineDetailsById({ id: fullId }).then(res => {
        if (res && res.code == 'A0000') {
            addForms.value.open({
                title: '重新发起',
                row: res.data
            })
        }
    })
}, { immediate: true })
</script>

<style scoped lang="scss">
:deep(.el-upload-list__item) {
    width: 400px;
}

::v-deep .el-input__wrapper {
    // width: 200px !important;
}
</style>
